package org.jeecg.modules.energy.controller;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.energy.entity.BuAirNoise;
import org.jeecg.modules.energy.entity.BuDipAngle;
import org.jeecg.modules.energy.service.IBuDipAngleService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: bu_dip_angle
 * @Author: jeecg-boot
 * @Date:   2024-11-15
 * @Version: V1.0
 */
@Api(tags="bu_dip_angle")
@RestController
@RequestMapping("/energy/buDipAngle")
@Slf4j
public class BuDipAngleController extends JeecgController<BuDipAngle, IBuDipAngleService> {
	@Autowired
	private IBuDipAngleService buDipAngleService;
	
	/**
	 * 分页列表查询
	 *
	 * @param buDipAngle
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "bu_dip_angle-分页列表查询")
	@ApiOperation(value="倾角分页列表查询", notes="倾角分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<BuDipAngle>> queryPageList(BuDipAngle buDipAngle,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BuDipAngle> queryWrapper = QueryGenerator.initQueryWrapper(buDipAngle, req.getParameterMap());
		Page<BuDipAngle> page = new Page<BuDipAngle>(pageNo, pageSize);
		IPage<BuDipAngle> pageList = buDipAngleService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	 @AutoLog(value = "倾角传感器数据-首页查询")
	 @ApiOperation(value="倾角传感器数据-首页查询", notes="倾角传感器数据-首页查询")
	 @GetMapping(value = "/getDipAngleData")
	 public Result<?> getDipAngleData() {
		 List<BuDipAngle> buDipAngleList = buDipAngleService.getDipAngleData();
		 List<List<String>> lists = new ArrayList<>();
		 SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		 for (BuDipAngle buDipAngle : buDipAngleList) {
			 buDipAngle.setDeviceName(buDipAngle.getDeviceName()+buDipAngle.getDeviceCode());
			 buDipAngle.setAngle(buDipAngle.getXAngle().toString()+","+buDipAngle.getYAngle().toString()+","+buDipAngle.getZAngle().toString());
		 }
		 return Result.OK(buDipAngleList);
	 }
	
	/**
	 *   添加
	 *
	 * @param buDipAngle
	 * @return
	 */
	@AutoLog(value = "bu_dip_angle-添加")
	@ApiOperation(value="bu_dip_angle-添加", notes="bu_dip_angle-添加")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_dip_angle:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody BuDipAngle buDipAngle) {
		buDipAngleService.save(buDipAngle);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param buDipAngle
	 * @return
	 */
	@AutoLog(value = "bu_dip_angle-编辑")
	@ApiOperation(value="bu_dip_angle-编辑", notes="bu_dip_angle-编辑")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_dip_angle:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody BuDipAngle buDipAngle) {
		buDipAngleService.updateById(buDipAngle);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "bu_dip_angle-通过id删除")
	@ApiOperation(value="bu_dip_angle-通过id删除", notes="bu_dip_angle-通过id删除")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_dip_angle:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		buDipAngleService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "bu_dip_angle-批量删除")
	@ApiOperation(value="bu_dip_angle-批量删除", notes="bu_dip_angle-批量删除")
	//@RequiresPermissions("org.jeecg.modules.demo:bu_dip_angle:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buDipAngleService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "bu_dip_angle-通过id查询")
	@ApiOperation(value="bu_dip_angle-通过id查询", notes="bu_dip_angle-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<BuDipAngle> queryById(@RequestParam(name="id",required=true) String id) {
		BuDipAngle buDipAngle = buDipAngleService.getById(id);
		if(buDipAngle==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buDipAngle);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buDipAngle
    */
    //@RequiresPermissions("org.jeecg.modules.demo:bu_dip_angle:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuDipAngle buDipAngle) {
        return super.exportXls(request, buDipAngle, BuDipAngle.class, "bu_dip_angle");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_dip_angle:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuDipAngle.class);
    }

}
